section .data
maxlen  equ     25
quser   db      'Please, enter your name? ', 00h
huser   db      'Hello, '
hname   times   maxlen + 2 db 00h
hworld  db      'Hello, world!', 00h

section .bss
buffer  resb    maxlen + 1

section .text
extern io_get_string, io_print_string, io_newline
global main
main:
        mov     ebp, esp
        ; Ask for name
        mov     eax, quser
        call    io_print_string
        ; Get name from keyboard input
        mov     eax, buffer
        mov     edx, maxlen + 1
        call    io_get_string
        ; Prepare copy of name from buffer to greeting area
        lea     esi, [buffer]
        lea     edi, [hname]
        mov     al, [esi]
        ; If there is no input (user just hit ENTER key),
        ; the general greeting will be displayed
        cmp     al, 0Ah                ; 0Ah (linefeed) indicates end of input
        je      world
copychar:
        ; Copy name from buffer to greeting area
        ; This is done character by character, until LF or end of string is detected
        mov     [edi], al
        inc     esi
        inc     edi
        mov     al, [esi]
        cmp     al, 0Ah                ; check if character is LF
        je      done                   ; if yes, we're done
        cmp     al, 00h                ; check if end of string
        je      done                   ; if yes, we're done
        jmp     copychar               ; if not, continue with the next character
done:
        mov     byte [edi], '!'        ; add exclamation mark at the end of the name
        mov     eax, huser             ; load AX with address of personal greeting (for display)
        jmp     display
world:
        ; General greeting
        mov     eax, hworld            ; load AX with address of general greeting (for display)
display:
        ; Display (general or personal) greeting
        call    io_print_string
        call    io_newline
        xor     eax, eax
        ret
